const { refObject, Button, ImageButton, TextBox, Vector, world } = require('@tabletop-playground/api');
const { SetIdObject } = require('./general/General_Functions.js');
//-----------------------------------------------------------------
refObject.onCreated.add(() => {
  refObject.setState(0);
  SetIdObject(refObject.getId());
  loadState();
})

refObject.onStateChanged.add((obj, newState, oldState) => {
  if (newState == 1) {
    status2.HideUI();
    status.HideUI();
    limbCondition.ShowUI();
  } else if (newState == 0) {
    status2.ShowUI();
    status.ShowUI();
    limbCondition.HideUI();
  }
})
//-----------------------------------------------------------------
const zPosition = 0.05;
const widgetWidth = 1600;
const widgetHeight = 800;

let statusName = [
  "radiation",
  "poisoning",
  "drowsiness",
  "dehydration",
  "hunger",
  "breakdown"
]
let allStatus = [];
for (let i = 0; i < statusName.length; i++) {
  allStatus[statusName[i]] = new TextBox().setText("0").setMaxLength(4);
  allStatus[statusName[i]].setFontSize(38);
  allStatus[statusName[i]].setInputType(4);
  allStatus[statusName[i]].onTextChanged.add(() => {
    saveState();
  })
}
//-----------------
let countLimb = 8;
let allLimb = [];
for (let i = 0; i < countLimb; i++) {
  allLimb[i] = new TextBox().setText("100%").setEnabled(false);
  allLimb[i].setFontSize(34);
  allLimb[i].onTextChanged.add(() => {
    saveState();
  })
}
//-----------------
let status2Name = [
  "response",
  "armor",
  "damage_limit",
  "res_damage",
  "res_energy_damage",
  "res_radiation",
  "res_poison",
  "critical_hit_rate"
];
let majorStatus2 = [];
let baffStatus2 = [];
let baffStatusValue = [];
let debaffStatus2 = [];
let debaffStatusValue = [];
let mainStatus2 = [];
let mainStatusValue = [];
let startValueMainStatus = [];
for (let i = 0; i < status2Name.length; i++) {
  majorStatus2[status2Name[i]] = new TextBox().setText("0").setEnabled(false);
  majorStatus2[status2Name[i]].setFontSize(38);
  majorStatus2[status2Name[i]].onTextChanged.add(() => {
    if (status2Name[i] == "intelligence") {
      let current = parseInt(majorStatus2[status2Name[i]].getText());
      status2.GrowthRate = current;
    }
    saveState();
  })
  //--
  baffStatusValue[i] = 0;
  baffStatus2[status2Name[i]] = new TextBox().setText("0").setInputType(4);
  baffStatus2[status2Name[i]].setFontSize(20);
  baffStatus2[status2Name[i]].onTextChanged.add((_1, _2, text) => {
    baffStatusValue[i] = text;
    RecalculationMajorCharacteristic(status2Name[i]);
  })
  //--
  debaffStatusValue[i] = 0;
  debaffStatus2[status2Name[i]] = new TextBox().setText("0").setInputType(4);
  debaffStatus2[status2Name[i]].setFontSize(20);
  debaffStatus2[status2Name[i]].onTextChanged.add((_1, _2, text) => {
    debaffStatusValue[i] = text;
    RecalculationMajorCharacteristic(status2Name[i]);
  })
  //--
  mainStatusValue[i] = 0;
  mainStatus2[status2Name[i]] = new TextBox().setText("0").setInputType(4);
  mainStatus2[status2Name[i]].setFontSize(20);
  mainStatus2[status2Name[i]].onTextChanged.add((_1, _2, text) => {
    mainStatusValue[i] = text;
    RecalculationMajorCharacteristic(status2Name[i]);
  })
  //--
  startValueMainStatus[status2Name[i]] = 0;
}

function RecalculationMajorCharacteristic(type) {
  let main = startValueMainStatus[type] + parseInt(mainStatus2[type].getText());
  let debaff = parseInt(debaffStatus2[type].getText());
  let baff = parseInt(baffStatus2[type].getText());
  majorStatus2[type].setText(main + baff - debaff);
}

function CreateCharacteristicTextBox(parent, charName, position, typeChar, isMain) {
  let imageSize = 25;
  let offsetY = 20;
  let buttonOffsetY = offsetY + 5;

  let decrement = new ImageButton().setImage("minus.png");
  decrement.setImageSize(imageSize);
  decrement.onClicked.add(() => {
    let currentValue = typeChar[charName].getText();
    if (currentValue > 0) {
      typeChar[charName].setText(currentValue - 1);
    }
  })
  parent.addChild(decrement, position.x - 40, position.y + buttonOffsetY, 30, 30);
  //--
  parent.addChild(typeChar[charName], position.x, position.y + offsetY, 40, 40);
  //--
  let increment = new ImageButton().setImage("plus.png");
  increment.setImageSize(imageSize);
  increment.onClicked.add(() => {
    let currentValue = parseInt(typeChar[charName].getText());
    typeChar[charName].setText(currentValue + 1);
  })
  parent.addChild(increment, position.x + 50, position.y + buttonOffsetY, 30, 30);
}

function CreateLimbConditionTextBox(parent, index, position, array) {
  let imageSize = 100;
  let buttonOffsetY = 5;

  let decrement = new ImageButton().setImage("minus.png");
  decrement.setImageSize(imageSize);
  decrement.onClicked.add(() => {
    let currentValue = array[index].getText();
    currentValue = currentValue.slice(0, currentValue.indexOf("%")) - parent.box.getText();
    if (currentValue > 0) {
      array[index].setText(currentValue + "%");
    }
  })
  parent.nC.addChild(decrement, position.x - 55, position.y + buttonOffsetY, 50, 50);
  //--
  parent.nC.addChild(array[index], position.x, position.y, 125, 60);
  //--
  let increment = new ImageButton().setImage("plus.png");
  increment.setImageSize(imageSize);
  increment.onClicked.add(() => {
    let currentValue = array[index].getText();
    currentValue = parseInt(currentValue.slice(0, currentValue.indexOf("%"))) + parseInt(parent.box.getText());
    if (currentValue <= 100) {
      array[index].setText(currentValue + "%");
    }
  })
  parent.nC.addChild(increment, position.x + 130, position.y + buttonOffsetY, 50, 50);
}
//-----------------------------------------------------------------
class Status {
  constructor(parent, position) {
    this.parent = parent;
    this.showPosition = position;
    this.hidePosition = position.add(new Vector(0, 0, -zPosition));
    //-------------------------
    this.nC = new Canvas();

    this.nCUI = new UIElement();
    this.nCUI.useWidgetSize = false;
    this.nCUI.position = position;
    this.nCUI.widget = this.nC;
    this.nCUI.width = widgetWidth;
    this.nCUI.height = widgetHeight;
    this.nCUI.scale = 0.1;
    parent.attachUI(this.nCUI);
    //-------------------------
    let maxStatus = new TextBox().setText("/1000").setEnabled(false);
    maxStatus.setFontSize(38);
    for (let i = 0; i < statusName.length; i++) {
      this.nC.addChild(allStatus[statusName[i]], 380, 152 + i * 74, 130, 65);
      this.nC.addChild(maxStatus, 510, 152 + i * 74, 150, 65);
    }
  }

  HideUI() {
    this.nCUI.position = this.hidePosition;
    this.parent.updateUI(this.nCUI);
  }
  ShowUI() {
    this.nCUI.position = this.showPosition;
    this.parent.updateUI(this.nCUI);
  }
}
let status = new Status(refObject, new Vector(0, 0, zPosition));

class Status2 {
  constructor(parent, position) {
    this.parent = parent;
    this.maxPointsVal = 40;
    this.showPosition = position;
    this.hidePosition = position.add(new Vector(0, 0, -zPosition));
    //-------------------------
    this.nC = new Canvas();

    this.nCUI = new UIElement();
    this.nCUI.useWidgetSize = false;
    this.nCUI.position = position;
    this.nCUI.widget = this.nC;
    this.nCUI.width = widgetWidth;
    this.nCUI.height = widgetHeight;
    this.nCUI.scale = 0.1;
    parent.attachUI(this.nCUI);
    //-------------------------
    let borderBaff = new Border();
    borderBaff.setColor(new Color(0.05, 0, 1));
    this.nC.addChild(borderBaff, 1250, 100, 40, 40);
    //-------------------------
    let borderDebaff = new Border();
    borderDebaff.setColor(new Color(1, 0, 0.05));
    this.nC.addChild(borderDebaff, 1380, 100, 40, 40);
    //-------------------------
    let borderMain = new Border();
    borderMain.setColor(new Color(0.05, 1, 0.05));
    this.nC.addChild(borderMain, 1510, 100, 40, 40);
    //-------------------------
    for (let i = 0; i < status2Name.length; i++) {
      this.nC.addChild(majorStatus2[status2Name[i]], 1100, 152 + i * 74, 70, 65);
      CreateCharacteristicTextBox(this.nC, status2Name[i], position.add(new Vector(1250, 147 + i * 74, 0)), baffStatus2);
      CreateCharacteristicTextBox(this.nC, status2Name[i], position.add(new Vector(1380, 147 + i * 74, 0)), debaffStatus2);
      CreateCharacteristicTextBox(this.nC, status2Name[i], position.add(new Vector(1510, 147 + i * 74, 0)), mainStatus2, true);
    }
  }

  HideUI() {
    this.nCUI.position = this.hidePosition;
    this.parent.updateUI(this.nCUI);
  }
  ShowUI() {
    this.nCUI.position = this.showPosition;
    this.parent.updateUI(this.nCUI);
  }
}
let status2 = new Status2(refObject, new Vector(0, 0, zPosition));

class LimbCondition {
  constructor(parent, position) {
    this.parent = parent;
    this.showPosition = position.add(new Vector(0, 0, zPosition));
    this.hidePosition = position;
    //-------------------------
    this.nC = new Canvas();

    this.nCUI = new UIElement();
    this.nCUI.useWidgetSize = false;
    this.nCUI.position = position;
    this.nCUI.widget = this.nC;
    this.nCUI.width = widgetWidth;
    this.nCUI.height = widgetHeight;
    this.nCUI.scale = 0.1;
    parent.attachUI(this.nCUI);
    //-------------------------
    let offsetY = 0; let offsetX = 70;
    for (let i = 0; i < countLimb; i++, offsetY++) {
      CreateLimbConditionTextBox(this, i, position.add(new Vector(offsetX, 130 + offsetY * 140, 0)), allLimb);
      if (i == countLimb / 2 - 1) { offsetY = -1; offsetX = 1410; }
    }
    //-------------------------
    this.box = new Button().setText("1");
    this.box.setFontSize(40);
    this.nC.addChild(this.box, 780, 680, 70, 80);
    //-------------------------
    let t = this;
    let boxTable = [1, 5, 10, 25, 50];
    let boxIndex = 0;
    this.box.onClicked.add(function () {
      boxIndex++;
      if (boxIndex >= boxTable.length) {
        boxIndex = 0;
      }
      t.box.setText(boxTable[boxIndex]);
    });
  }

  HideUI() {
    this.nCUI.position = this.hidePosition;
    this.parent.updateUI(this.nCUI);
  }
  ShowUI() {
    this.nCUI.position = this.showPosition;
    this.parent.updateUI(this.nCUI);
  }
}
let limbCondition = new LimbCondition(refObject, new Vector(0, 0, 0));
//-----------------------------------------------------------------
function saveState() {
  let state = {};

  for (let i = 0; i < statusName.length; i++) {
    let index = statusName[i];
    state[index] = allStatus[index].getText();
  }
  for (let i = 0; i < status2Name.length; i++) {
    let index = status2Name[i];
    state[index + "ValMain"] = startValueMainStatus[index];
  }
  for (let i = 0; i < countLimb; i++) {
    state[i] = allLimb[i].getText();
  }

  state["Main"] = mainStatusValue;
  state["Baff"] = baffStatusValue;
  state["Debaff"] = debaffStatusValue;

  refObject.setSavedData(JSON.stringify(state));
}

function loadState() {
  if (refObject.getSavedData() === "") {
    saveState();
    return;
  }

  let state = JSON.parse(refObject.getSavedData());
  for (let i = 0; i < statusName.length; i++) {
    allStatus[statusName[i]].setText(state[statusName[i]] || "...");
  }
  for (let i = 0; i < status2Name.length; i++) {
    let index = status2Name[i];
    startValueMainStatus[index] = (state[index + "ValMain"] || 0);
  }
  for (let i = 0; i < countLimb; i++) {
    allLimb[i].setText(state[i] || "0");
  }
  mainStatusValue = state["Main"];
  baffStatusValue = state["Baff"];
  debaffStatusValue = state["Debaff"];
  for (let i = 0; i < status2Name.length; i++) {
    let index = status2Name[i];
    mainStatus2[index].setText(mainStatusValue[i] || "0");
    baffStatus2[index].setText(baffStatusValue[i] || "0");
    debaffStatus2[index].setText(debaffStatusValue[i] || "0");
    RecalculationMajorCharacteristic(index);
  }
}

refObject.ResetValue = function () {
  for (let i = 0; i < statusName.length; i++) {
    allStatus[statusName[i]].setText("...");
  }
  for (let i = 0; i < status2Name.length; i++) {
    let index = status2Name[i];
    majorStatus2[index].setText("0");
    baffStatus2[index].setText("0");
    debaffStatus2[index].setText("0");
    mainStatus2[index].setText("0");
    startValueMainStatus[index] = 0;
  }
  saveState();
}

refObject.RecalculationMain = (array) => {
  startValueMainStatus["response"] = array["perception"] * 2;
  startValueMainStatus["armor"] = array["dextery"];
  startValueMainStatus["res_radiation"] = array["endurance"] * 2;
  startValueMainStatus["res_poison"] = array["endurance"] * 5;
  startValueMainStatus["critical_hit_rate"] = array["luck"];
  for (let i = 0; i < status2Name.length; i++) {
    RecalculationMajorCharacteristic(status2Name[i]);
  }
}